# -*- coding: utf-8 -*-

import pygst
pygst.require("0.10")
import gst, gobject
gobject.threads_init()

# Importa todos los módulos disponibles
#import TCP_IS_oneway_push
#import TCP_IS_toway_push
#import TCP_pull
#import TCP_push
import UDP_IS_oneway_push
#import UDP_push

def parse_launch(ps):
    srcstr = ps[:ps.find("!")].strip()
    sinkstr = ps[ps.rfind("!")+1:].strip()
    fname = None
    lname = None
    src = None
    sink = None

    if srcstr.startswith("gsticesrc"):
        ps = ps[ps.find("!")+1:].strip()
        
        next = ps[:ps.find("!")].strip()
        for i in next.split():
            if i.startswith("name"):
                fname = i[5:]
                break
        if not fname:
            fname = next.split()[0]+"_1"
            next = next+" name=%s" % fname
            ps = next+" ! "+ps[ps.find("!")+1:].strip()

        srcname = "gst-ice-src"
        for i in srcstr.split():
            if i.startswith("name"):
                srcname = i[5:]
                break            

        src = UDP_IS_oneway_push.gstIceSrc(srcname)

    if sinkstr.startswith("gsticesink"):
        ps = ps[:ps.rfind("!")].strip()

        last = ps[ps.rfind("!")+1:]
        for i in last.split():
            if i.startswith("name"):
                lname = i[5:]
                break
        if not lname:
            lname = last.split()[0]+"_1"
            last = last+" name=%s" % lname
            ps = ps[:ps.rfind("!")+1]+last

        sinkname = "gst-ice-sink"
        for i in sinkstr.split():
            if i.startswith("name"):
                sinkname = i[5:]
                break

        sink = UDP_IS_oneway_push.gstIceSink(sinkname)

    pipe = gst.parse_launch(ps)
    if not isinstance(pipe, gst.Pipeline):
        elem = pipe
        pipe = gst.Pipeline("pipeline1")
        pipe.add(elem)

    if src:
        pipe.add(src)    
        first = pipe.get_by_name(fname)
        gst.element_link_many(src, first)

    if sink:
        pipe.add(sink)
        last = pipe.get_by_name(lname)
        gst.element_link_many(last, sink)

    return pipe





